﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace ComPortRead
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string[] theSerialPortNames = System.IO.Ports.SerialPort.GetPortNames();
            foreach (var port in theSerialPortNames)
            {
                listBox1.Items.Add(port);
            }
            //listBox1.Items.Add("COM8");
            //listBox1.Items.Add("COM9");
            tx = textBox1;
        }

        SerialPort mySerialPort = null;

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            mySerialPort = new SerialPort((string)listBox1.SelectedItem);

            mySerialPort.BaudRate = 9600;
            mySerialPort.Parity = Parity.None;
            mySerialPort.StopBits = StopBits.One;
            mySerialPort.DataBits = 8;
            mySerialPort.Handshake = Handshake.None;

            mySerialPort.DataReceived += new SerialDataReceivedEventHandler(DataReceivedHandler);

            mySerialPort.Open();

            tx.Text += "port " + (string)listBox1.SelectedItem + " opened\r\n";
        }
        static TextBox tx=null;
        private static void DataReceivedHandler(object sender, SerialDataReceivedEventArgs e)
        {
            SerialPort sp = (SerialPort)sender;
            //tx.Text += sp.ReadExisting()+" ";
            byte[]buff=new byte[1];
            sp.Read(buff,0,1);
            tx.Text +=buff[0].ToString()+" ";
            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            mySerialPort.Write(new byte[] { 0 }, 0, 1);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            mySerialPort.Write(new byte[] { 1 }, 0, 1);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            mySerialPort.Write(new byte[] { 2 }, 0, 1);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            Invalidate();
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            if (textBox1.Text.Split(' ').Count() == 32)
            {
                string[] numbers = textBox1.Text.Split(' ');
                int[] int_vals = numbers.Select(x => int.Parse(x)).ToArray();
                int min = int_vals.Min();
                
                int_vals = int_vals.Select(x => x - min).ToArray();
                int_vals = int_vals.Select(x => x*2).ToArray();
                double avg = int_vals.Average();
                e.Graphics.DrawLine(Pens.Green, 600, 400, 700, 400);
                e.Graphics.DrawLine(Pens.Green, 650, 350, 650, 450);
                //650 400 center
                double steps_of_circle = 100;
                for (int i = 0; i < steps_of_circle; i+=2)
                {
                    //x = r cos fi
                    //y = r sin fi
                    double x = 200 * Math.Cos(2.0 * Math.PI / steps_of_circle * i);
                    double y = 200 * Math.Sin(2.0 * Math.PI / steps_of_circle * i);

                    double x1 = 200 * Math.Cos(2.0 * Math.PI / steps_of_circle * (i+1));
                    double y1 = 200 * Math.Sin(2.0 * Math.PI / steps_of_circle * (i+1));

                    e.Graphics.DrawLine(Pens.Green, (int)x + 650, (int)y + 400, (int)x1 + 650, (int)y1 + 400);
                }
                Font f= new Font("system",8);
                for (int i = 0; i < 32; i++)
                {
                    //x = r cos fi
                    //y = r sin fi
                    double x = (200 - int_vals[i] + avg) * Math.Cos(2.0 * Math.PI / 32.0 * i);
                    double y = (200 - int_vals[i] + avg) * Math.Sin(2.0 * Math.PI / 32.0 * i);

                    e.Graphics.DrawString(i.ToString(), f, Brushes.Red, (float)x+650f, (float)y+400f);

                    double x1 = (200 - int_vals[(i == 31 ? -1 : i) + 1] + avg) * Math.Cos(2.0 * Math.PI / 32.0 * (i + 1));
                    double y1 = (200 - int_vals[(i == 31 ? -1 : i) + 1] + avg) * Math.Sin(2.0 * Math.PI / 32.0 * (i + 1));

                    e.Graphics.DrawLine(Pens.Red, (int)x + 650, (int)y + 400, (int)x1 + 650, (int)y1 + 400);
                }
            }
        }
    }
}
